<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [rightTemplate]="rightTemplate"
                                [leftTemplate]="leftTemplate"
  ></solidify-detail-presentation>


  <ng-template #leftTemplate>
    <solidify-image-upload-wrapper-container [defaultIcon]="iconNameEnum.licenses"
                                             [resourceFileNameSpace]="adminLicenseActionNamespace"
                                             [resourceFileState]="$any(adminLicenseState)"
                                             [uploadInstantly]="false"
                                             [isEditable]="(model | isNullOrUndefined) || editAvailable"
                                             (logoChange)="logoChange($event)"
    ></solidify-image-upload-wrapper-container>
  </ng-template>

  <ng-template #centerTemplate>
    <mat-form-field *ngIf="getFormControl(formDefinition.title) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.title | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.openLicenseId) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.openLicenseId | translate}}</mat-label>
      <input (blur)="checkAvailable(formDefinition.openLicenseId, fd)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <solidify-url-input-navigator *ngIf="getFormControl(formDefinition.url) as fd"
                                  [formControl]="fd"
    >
    </solidify-url-input-navigator>

    <mat-form-field *ngIf="getFormControl(formDefinition.odConformance) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.odConformance | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let odConformance of licenseOdConformanceEnum"
                    [value]="odConformance.key"
                    solidifyTooltipOnEllipsis
        >
          {{odConformance.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.osdConformance) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.osdConformance | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let osdConformance of licenseOsdConformanceEnum"
                    [value]="osdConformance.key"
                    solidifyTooltipOnEllipsis
        >
          {{osdConformance.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.maintainer) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.maintainer | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-checkbox [formControlName]="formDefinition.isGeneric"
                  color="primary"
    >{{labelTranslateEnum.isGeneric | translate }}</mat-checkbox>

    <mat-form-field *ngIf="getFormControl(formDefinition.family) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.family | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>


  </ng-template>

  <ng-template #rightTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.status) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.status | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let status of licensesStatusEnum"
                    [value]="status.key"
                    solidifyTooltipOnEllipsis
        >
          {{status.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-checkbox [formControlName]="formDefinition.domainContent"
                  color="primary"
    >{{labelTranslateEnum.domainContent | translate }}</mat-checkbox>

    <mat-checkbox [formControlName]="formDefinition.domainData"
                  color="primary"
    >{{labelTranslateEnum.domainData | translate }}</mat-checkbox>

    <mat-checkbox [formControlName]="formDefinition.domainSoftware"
                  color="primary"
    >{{labelTranslateEnum.domainSoftware | translate }}</mat-checkbox>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
